var clipboardHelper = Cc["@mozilla.org/widget/clipboardhelper;1"].
                      getService(Ci.nsIClipboardHelper);

exports.setText = function(text) {
  clipboardHelper.copyString(text);
};

exports.getText = function() {
  // Original code found at https://developer.mozilla.org/en/Using_the_Clipboard
  var clip = Cc["@mozilla.org/widget/clipboard;1"].getService(Ci.nsIClipboard);
  if (!clip)
    return null;
  var trans = Cc["@mozilla.org/widget/transferable;1"].createInstance(Ci.nsITransferable);
  if (!trans)
    return null;
  trans.addDataFlavor("text/unicode");
  clip.getData(trans, clip.kGlobalClipboard);
  var str = {}, len = {};
  trans.getTransferData("text/unicode", str, len); 
  if (!str)
    return null;
  str = str.value.QueryInterface(Ci.nsISupportsString);
  if (!str)
    return null;
  return str.data.substring(0, len.value / 2);
};

